<!DOCTYPE html>
<html>

<head>
  <meta charset="utf-8" name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
  <!-- Import DataTable Library -->
  <link rel="stylesheet" href="https://cdn.datatables.net/1.13.4/css/jquery.dataTables.min.css">
  <script src="https://cdn.datatables.net/1.13.4/js/jquery.dataTables.min.js"></script>
  <script src="https://cdnjs.cloudflare.com/ajax/libs/datatables.net-bs4/3.2.2/dataTables.bootstrap4.min.js"
    integrity="sha512-zjnVNy8zmH0JujmJgrADeEjpVIrafOQm2iQSbKk5dAiUBa18xYI2035PpojcvHKLKgDHPUdA3FoxneTC/RooGw=="
    crossorigin="anonymous" referrerpolicy="no-referrer">
    </script>
  <script src="https://cdnjs.cloudflare.com/ajax/libs/datatables/1.10.21/js/jquery.dataTables.min.js"
    integrity="sha512-BkpSL20WETFylMrcirBahHfSnY++H2O1W+UnEEO4yNIl+jI2+zowyoGJpbtk6bx97fBXf++WJHSSK2MV4ghPcg=="
    crossorigin="anonymous" referrerpolicy="no-referrer">
    </script>
  <script>
    "use strict";
    /* Mảng userObjects là mảng chứa dữ liệu user. Từng phần tử là object
    */
    var gStudents = [
      {
        id: 2, // tự tăng
        studentCode: "1356783",
        firstname: "Ngo Van",
        lastname: "Quan",
        age: 18,
        email: "quan@gmail.com",
        studyYear: 2015
      },
      {
        id: 3, // tự tăng
        studentCode: "1356784",
        firstname: "Le Van",
        lastname: "Trung",
        age: 18,
        email: "trung@gmail.com",
        studyYear: 2015
      }, {
        id: 4, // tự tăng
        studentCode: "1356785",
        firstname: "Ngo Van",
        lastname: "Duong",
        age: 18,
        email: "duong@gmail.com",
        studyYear: 2015
      }, {
        id: 5, // tự tăng
        studentCode: "1356786",
        firstname: "Le Van",
        lastname: "Luyen",
        age: 18,
        email: "Luyen@gmail.com",
        studyYear: 2015
      }, {
        id: 6, // tự tăng
        studentCode: "1356783",
        firstname: "Hai",
        lastname: "Banh",
        age: 18,
        email: "hai@gmail.com",
        studyYear: 2015
      },

    ];

    var gSubjects = [
      {
        id: 2, // tự tăng
        subjectCode: "MATH101",
        subjectName: "Toán cao cấp 1"
      },
      // điền thêm 04 môn học nữa
      {
        id: 3, // tự tăng
        subjectCode: "SUCBEN",
        subjectName: "Sức bền vật liệu"
      }, {
        id: 4, // tự tăng
        subjectCode: "CKC",
        subjectName: "Cơ kết cấu"
      }, {
        id: 5, // tự tăng
        subjectCode: "THUYVAN",
        subjectName: "Thủy văn"
      }, {
        id: 6, // tự tăng
        subjectCode: "CHD",
        subjectName: "Cơ học đất"
      }, {
        id: 7, // tự tăng
        subjectCode: "CNTT",
        subjectName: "Công nghệ thông tin"
      },
    ];

    var gGrades = [
      {
        id: 2, // tự tăng
        studentId: 2,
        subjectId: 5,
        grade: 8,
        examDate: "13/04/2021"
      },
      // điền thêm 9 kết quả thi nữa
      {
        id: 3, // tự tăng
        studentId: 3,
        subjectId: 3,
        grade: 5,
        examDate: "13/04/2021"
      }, {
        id: 4, // tự tăng
        studentId: 4,
        subjectId: 7,
        grade: 9,
        examDate: "13/04/2021"
      }, {
        id: 5, // tự tăng
        studentId: 5,
        subjectId: 4,
        grade: 8,
        examDate: "13/04/2021"
      }, {
        id: 6, // tự tăng
        studentId: 6,
        subjectId: 5,
        grade: 10,
        examDate: "13/04/2021"
      }, {
        id: 7, // tự tăng
        studentId: 5,
        subjectId: 6,
        grade: 8,
        examDate: "13/04/2021"
      }, {
        id: 8, // tự tăng
        studentId: 4,
        subjectId: 5,
        grade: 7,
        examDate: "13/04/2021"
      }, {
        id: 9, // tự tăng
        studentId: 3,
        subjectId: 4,
        grade: 8.5,
        examDate: "13/04/2021"
      }, {
        id: 10, // tự tăng
        studentId: 2,
        subjectId: 3,
        grade: 5,
        examDate: "13/04/2021"
      }, {
        id: 11, // tự tăng
        studentId: 4,
        subjectId: 2,
        grade: 8,
        examDate: "13/04/2021"
      },
    ];
  </script>
</head>

<body>
  <div class="container">
    <div class="text-center mt-2 mb-2">
      <h2>F200 - LỊCH SỬ HỌC TẬP</h2>
    </div>
    <div class="jumbotron container">
      <h2>Thông tin người chơi:</h2>
      <div class="row form-group mt-4">
        <div class="col-sm-5">
          <div class="row align-items-center">
            <div class="col-sm-4">
              <label class="h5" for="select-student">Student</label>
            </div>
            <div class="col-sm-8">
              <select id="select-student" class="form-control btn-info">

              </select>
            </div>
          </div>
        </div>
        <div class="col-sm-5">
          <div class="row align-items-center">
            <div class="col-sm-4">
              <label class="h5" for="select-subject">Subject</label>
            </div>
            <div class="col-sm-8">
              <select id="select-subject" class="form-control btn-info">

              </select>
            </div>
          </div>
        </div>
        <div class="col-sm-2">
          <button id="btn-filter-order" class="btn btn-success">Lọc dữ liệu</button>
        </div>
      </div>
    </div>
    <div class="mt-5" id="log-result">

    </div>
    <div class="container">
      <table class="table table-bordered table-striped table-hover" id="student-table">
        <thead>
          <tr class="btn-primary">
            <th>STT</th>
            <th>Student</th>
            <th>Môn học</th>
            <th>Điểm</th>
            <th>Ngày thi</th>
          </tr>
        </thead>
      </table>
    </div>
</body>
<script>
  /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
  var gSTT = 1;

  const STUDENT_TALBLE_COLS = ["id", "studentId", "subjectId", "grade", "examDate"];
  const COL_STT = 0;
  const COL_STUDENT = 1;
  const COL_SUBJECT = 2;
  const COL_GRADE = 3;
  const COL_EXAMDATE = 4;

  var vStudentGradeDataTable = $("#student-table").DataTable({
    columns: [
      { data: STUDENT_TALBLE_COLS[COL_STT] },
      { data: STUDENT_TALBLE_COLS[COL_STUDENT] },
      { data: STUDENT_TALBLE_COLS[COL_SUBJECT] },
      { data: STUDENT_TALBLE_COLS[COL_GRADE] },
      { data: STUDENT_TALBLE_COLS[COL_EXAMDATE] },
    ],
    columnDefs: [
      {
        targets: COL_STT,
        class: "text-center",
        render: function () {
          return gSTT++;
        }
      },
      {
        targets: COL_STUDENT,
        class: "text-center",
        render: function (paramData) {
          for (var bI = 0; bI < gStudents.length; bI++) {
            if (paramData == gStudents[bI].id) {
              return gStudents[bI].firstname + " " + gStudents[bI].lastname;
            }
          }
        }
      },
      {
        targets: COL_SUBJECT,
        class: "text-center",
        render: function (paramData) {
          for (var bI = 0; bI < gSubjects.length; bI++) {
            if (paramData == gSubjects[bI].id) {
              return gSubjects[bI].subjectName;
            }
          }
        }
      },
    ]
  })
  /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
  $(document).ready(function () {
    //hàm xử lý tải trang
    onPageLoading();
    //hàm xử lý nút lọc
    $("#btn-filter-order").on("click", function () {
      onBtnFilterClick();
    })
  });

  /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
  function onPageLoading() {
    loadDataToStudentTable(gGrades);
    $("#student-table_info").html(`Có ${gGrades.length} bản ghi thõa mãn!`)
    loadDataToStudentSelect(gStudents);
    loadDataToSubjectSelect(gSubjects);
  }

  // hàm xử lí khi click nút lọc dữ liệu
  function onBtnFilterClick() {
    // Tạo đối tượng chứa đối tượng lọc
    var vFilter = {
      studentId: 0,
      subjectId: 0,
    }
    // B1 thu thập dữ liệu lọc
    getData(vFilter);
    console.log(vFilter);
    // B2 kiểm tra 

    // B3 Lọc dữ liệu
    vResultFilter = filterData(vFilter);
    console.log(vResultFilter);
    // B4 hiển thị kết quả thu thập
    displayDataFilter(vResultFilter);
    $("#student-table_info").html(`Có ${vResultFilter.length} bản ghi thõa mãn!`)
  }
  /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
  function loadDataToStudentTable(paramData) {
    vStudentGradeDataTable.clear();
    vStudentGradeDataTable.rows.add(paramData);
    vStudentGradeDataTable.draw();
  }

  // hàm đẩy dữ liệu vào ô select
  function loadDataToStudentSelect(paramStudents) {
    $('#select-student').append($('<option>', {
      value: 0,
      text: '--Chọn Học sinh--'
    }));
    for (var bI = 0; bI < paramStudents.length; bI++) {
      $('#select-student').append($('<option>', {
        value: paramStudents[bI].id,
        text: paramStudents[bI].firstname + " " + paramStudents[bI].lastname
      }));
    }
  }
  function loadDataToSubjectSelect(paramSubjects) {
    $('#select-subject').append($('<option>', {
      value: 0,
      text: '--Chọn Môn Học--'
    }));
    for (var bI = 0; bI < paramSubjects.length; bI++) {
      $('#select-subject').append($('<option>', {
        value: paramSubjects[bI].id,
        text: paramSubjects[bI].subjectName
      }));
    }
  }

  // hàm thu thập dữ liệu lọc
  function getData(paramFilter) {
    paramFilter.studentId = $("#select-student").val();
    paramFilter.subjectId = $("#select-subject").val();
  }
  // hàm lọc dữ liệu
  function filterData(paramFilter) {
    var vResultFilter = [];
    vResultFilter = gGrades.filter(function (item) {
      return (item.studentId == paramFilter.studentId && item.subjectId == paramFilter.subjectId) ||
        (item.studentId == paramFilter.studentId && paramFilter.subjectId == 0) ||
        (item.subjectId == paramFilter.subjectId && paramFilter.studentId == 0) ||
        (paramFilter.studentId == 0 && paramFilter.subjectId == 0)
        ;
    })
    return vResultFilter;
  }
  // hàm hiển thị kết quả lọc được
  function displayDataFilter(paramResultFilter) {
    gSTT = 1;
    vStudentGradeDataTable.clear();
    vStudentGradeDataTable.rows.add(paramResultFilter);
    vStudentGradeDataTable.draw();
  }
</script>

</html>